/**************************************************************/
/* Fichier contenant les procedures d'affichage des resultats */
/**************************************************************/


#include <stdio.h>
#include "struct.h"
#include "affichage.h"
#include "pointeur.h"
#include "incomp.h"


/* Fonction affichant les resultats sous forme d'une somme de produits : */
/* affiche le terme (val,masque) en utilisant soit les variables entrees */
/* par l'utilisateur, soit les lettres dans l'ordre alphabetique */

void affich_SP(val, masque, taille, list_var)
    int val,masque,taille;
    varia * list_var;
{
    int i,mas,masquage,valeur;
    varia * v;

    mas = 1;

    for(i=1;i<taille;i++)
	mas = mas*2;

    for(i=taille-1;i>=0;i--)
    {
	masquage = 0;
	valeur = 0;
	if ((masque & mas) == mas)
	    masquage=1;

	if ((val & mas) == mas)
	    valeur=1;

	if  (!masquage && valeur)
	{
	    if (list_var == NULL)
		printf("%c*",97+taille-1-i);
	    else
		printf("%s*",list_var->var);
	}
		
	if (!masquage && !valeur)
	{
	    if (list_var == NULL)
		printf("/%c*",97+taille-1-i);
	    else
		printf("/%s*",list_var->var);
	}

	mas = mas >>  1;

	if (list_var != NULL)
	    list_var = list_var->suiv;
    }
}


/* Fonction affichant les resultats sous forme d'un produit de sommes */
/* (idem que pour la fonction precedente) */

void affich_PS (val,masque,taille,list_var)
    int val,masque,taille;
    varia * list_var;
{
    int i,mas,masquage,valeur;
    mas = 1;

    for(i=1;i<taille;i++)
	mas = mas*2;
    printf("(");
    for(i=taille-1;i>=0;i--)
    {
	masquage = 0;
	valeur = 0;
	if ((masque & mas) == mas)
	    masquage=1;

	if ((val & mas) == mas)
	    valeur=1;

	if  (!masquage && valeur)
	{
	    if (list_var == NULL)
		printf(" /%c +",97+taille-1-i);
	    else
		printf(" /%s +",list_var->var);
	}

	if (!masquage && !valeur)
	{
	    if (list_var == NULL)
		printf(" %c +",97+taille-1-i);
	    else
		printf(" %s +",list_var->var);
	}

	mas = mas >>  1;

	if (list_var != NULL)
	    list_var = list_var->suiv;
    }
    printf("%c)",8);
}


/* Fonction globale d'affichage des resultats contenus dans la */
/* variable t; cette fonction fait plusieurs fois appel aux */
/* deux precedentes */

void affiche(i,n,choix,t,comp,incomp,list_var)
    int i, n;
    int choix;
    cell * t;
    mint * comp;
    mint * incomp;
    varia * list_var;
{
    mint * ent;
    cell * c;
    int p;

    c = t;
    p = 1;

    if (t == NULL)
    {
	if (choix == 1)
	    printf("0\n");
	else
	    printf("1\n");
    }
    else
    {
	p = p << n;
	p--;
	if (t->masque == p)
	{
	    if (choix == 1)
		printf("1\n");
	    else
		printf("0\n");
	}
    }

    if (choix == 1)
    {
	/* on veut le resultat sous forme somme de produits */
	while (c != NULL)
	{
	    affich_SP(c->valeur,c->masque,n,list_var);
	    c = c->suiv;
	    if (c != NULL)
		printf("%c + ",8);
	}
	printf("%c  ",8);
    }
    if (choix == 2)
    {
	/* on veut le resultat sous forme produit de somme */
	while (c != NULL)
	{
	    affich_PS(c->valeur,c->masque,n,list_var);
	    c = c->suiv;
	    if (c != NULL)
		printf(" * ");
	}
    }

    if ((incomp != NULL) && (i == 1))
    {
	/* on avait affaire a une fonction incomplete */

	printf("\n\nLes minterms retenus pour la fonction complete sont :\n");
	ent = comp;
	while (ent != NULL)
	{
	    /* le minterm ent->numero a-t-il ete retenu ? */

	    if (((choix == 1) && (appartient(ent->numero,t))) ||
		((choix == 2) && (!appartient(ent->numero,t))))
		printf("%d ",ent->numero);
	    ent = ent->next;
	}
     }
}


/* Fonction retournant la liste complementaire de reunion parmi   */
/* les entiers compris de 0 a taille-1 (taille = nb de variables) */

mint * complement(reunion,taille)
    mint * reunion;
    int taille;
{
    int i, trouve, sup;
    mint * compl,* prov,* destruct;

    destruct = reunion;
    compl = NULL;
    sup = 1;

    for (i=0;i<taille;i++)
	sup = sup*2;

    for(i=0;i<sup;i++)
    {
	trouve = 0;
	destruct = reunion;
	while ((destruct != NULL) && (!trouve))
	{
	    if (destruct->numero == i)
		trouve = 1;
	    else
		destruct = destruct->next;
	}
	if (!trouve)
	{
	    if (compl == NULL)
	    {
		compl = new_mint(i);
		prov = compl;
	    }
	    else
	    {
		prov->next = new_mint(i);
		prov = prov->next;
	    }
	}
    }

    del_mint(reunion);

    return compl;
}


mint * comple(reunion,taille,inc)
    mint * reunion;
    int taille;
    mint * inc;
{
    int i, trouve, compt, sup;
    mint * compl,* prov,* destruct, * in;

    destruct = reunion;
    compt = 0;
    sup = 1;

    for (i=0;i<taille;i++)
	sup = sup*2;

    for(i=0;i<sup;i++)
    {
	in = inc;
	trouve = 0;
	destruct = reunion;
	while ((destruct != NULL) && (!trouve))
	{
	    if (destruct->numero == i)
		trouve = 1;
	    else
		destruct = destruct->next;
	}
	while ((in != NULL) && (!trouve))
	{
	    if (in->numero == i)
		trouve = 1;
	    else
		in = in->next;
	}
	if (!trouve)
	{
	    if (!compt)
	    {
		compl = new_mint(i);
		prov = compl;
		compt=1;
	    }
	    else
	    {
		prov->next = new_mint(i);
		prov = prov->next;
	    }
	}
    }

    del_mint(reunion);

    return compl;
}
