/****************************************************/
/* Fichier de traitement des circuits combinatoires */
/****************************************************/


#include <stdio.h>
#include "struct.h"
#include "simpl.h"
#include "pointeur.h"
#include "affichage.h"
#include "incomp.h"
#include "entree.h"
#include "lex.h"
#include "scrut.h"

void comb()
{
    mint * comp, * incomp;
    int n, choix;
    cell * c;
    varia * list_var;

    printf("\nVoulez-vous entrer votre fonction sous forme :\n");
    printf("  - d'une succession de minterms (tapez 1)\n");
    printf("  - d'une somme de produits (tapez 2)\n");
    printf("\n\tVotre choix ? ");
    choix=scrut();

    printf("\nNombre de variables ? ");
    n=scrut();
    printf("\n");

    if (choix == 1)
    {
	entree(n,&comp,&incomp);
	if ((incomp != NULL) && (comp != NULL))
	{
	    c = prepare(n,&comp,incomp);
	    del_cell(c);
	}
	list_var = variable(1,n);
    }
    else
    {
	incomp = NULL;
	list_var = variable(1,n);
	printf("\n");
	comp = entree_chaine(list_var,n);
	if (comp == NULL)
	    exit(0);
    }

    choix = 0;
    while (choix != 3)
    {
	printf("\nDesirez vous avoir le resultat :\n");
	printf("   Sous la forme d'une somme de produits (tapez '1') \n");
	printf("   Sous la forme d'un produit de sommes (tapez '2') \n");
	printf("   Sortie (tapez '3') \n");
	printf("\n\tVotre choix ? ");
	choix=scrut();

	if (choix != 3)
	{
	    if (choix == 2)
		comp = complement(comp,n);

	    if (comp != NULL)
		c = simplifie(n,comp,incomp);
	    else
		c = NULL;

	    if (choix == 2)
		comp = complement(comp,n);

	    printf("\nResultats :\n\n");
	    printf("F = ");
	    affiche(1,n,choix,c,comp,incomp,list_var);
	    printf("\n\n");

	    del_cell(c);
	}
    }

    del_varia(list_var);
    del_mint(comp);
    del_mint(incomp);
}
