/**************************************************/
/* Fichier contenant des fonctions utilisees pour */
/*    le traitement des fonctions incompletes     */
/**************************************************/


#include <stdio.h>
#include "struct.h"
#include "pointeur.h"
#include "simpl.h"
#include "incomp.h"


/* Fonction renvoyant 1 si le minterm num appartient */
/* au mint * m et 0 sinon */

int appart(num,m)
    int num;
    mint * m;
{
    int ret = 0;

    while ((!ret) && (m != NULL))
    {
	if (m->numero == num)
	    ret = 1;
	else
	    m = m->next;
    }

    return ret;
}


/* Fonction renvoyant 1 si le minterm num appartient */
/* au cell * c et 0 sinon */

int appartient(num,c)
    int num;
    cell * c;
{
    int trouve = 0;

    while ((!trouve) && (c != NULL))
    {
	if (appart(num,c->no))
	    trouve = 1;
	c = c->suiv;
    }

    return trouve;
}


/* Fonction permettant de choisir, dans le cas d'une fonction */
/* incomplete, quels termes phi seront finalement pris egaux  */
/* a 1; le mint * retourne contient tous les termes qui       */
/* vaudront 1 */

cell * prepare(n,comp,incomp)
    int n;
    mint ** comp;
    mint * incomp;
{
    mint * reunion, * ent, * a;
    cell * t;

    /* reunion est la concatenation de *comp et de incomp */
    reunion = NULL;

    a = *comp;
    while (a != NULL)
    {
	if (reunion == NULL)
	{
	    reunion = new_mint(a->numero);
	    ent = reunion;
	}
	else
	{
	    ent->next = new_mint(a->numero);
	    ent = ent->next;
	}
	a = a->next;
    }
    a = incomp;
    while (a != NULL)
    {
	if (reunion == NULL)
	{
	    reunion = new_mint(a->numero);
	    ent = reunion;
	}
	else
	{
	    ent->next = new_mint(a->numero);
	    ent = ent->next;
	}
	a = a->next;
    }

    /* simplification avec tous les termes incomplets egaux a 1 */
    t = simplifie(n,reunion,incomp);
    del_mint(reunion);

    a = *comp;
    while ((a->next) != NULL)
	a = a->next;
    while (incomp != NULL)
    {
	if (appartient(incomp->numero,t))
	{
	    a->next = new_mint(incomp->numero);
	    a = a->next;
	}
	incomp = incomp->next;
    }

    return t;
}
