/********************************************************/
/* Fichier contenant les fonctions d'analyses lexicales */
/*          et syntaxiques de la chaine entree          */
/********************************************************/


#include<stdio.h>
#include <ctype.h>
#include "struct.h"
#include "pointeur.h"
#include <string.h>
#include <stdlib.h>



char * chaine;
int TAILLE;


/* Supprime les espaces et retourne le premier caractere de chaine */

char lire_c()
{
    while (*chaine == ' ')
	chaine ++;
    return (*chaine);
}


/* retourne 1 si le caractere lu est une variable valable */

int lire_identifiant_c()
{
    int k, dif;
    char * prov;

    k = 0;
    prov = chaine;
    while (*prov == ' ')
	prov ++;

    dif = TAILLE - *prov + 97;
    while (islower(*prov))
    {
	prov++;
	k++;
    }
    chaine = prov;

    if ((k == 1) && (dif > 0))
	return 1;
    else
	return 0;
}


/* idem dans le cas ou l'utilisateur a choisi ses propres variables */

int lire_identifiant_chaine(list_var)
    varia * list_var;
{
    int k;
    char c;
    char * prov, * copi, *renvoi;
    renvoi = (char *) malloc(50);

    k = 0;
    prov = chaine;

    while (*prov == ' ')
	prov ++;

    copi = prov;
    while (isalnum(*prov))
    {
	prov++;
	k++;
    }

    c = *prov;
    *prov = '\0';
    strncpy(renvoi,copi,k+1);
    *prov = c;
    chaine = prov;

    while (list_var != NULL)
    {
	if (!strcmp(renvoi,list_var->var))
	{
	    free(renvoi);
	    return 1;
	}
	list_var = list_var->suiv;
    }
    free(renvoi);

    return 0;
}


/* Les trois fonctions suivantes sont les fonctions d'analyse     */
/* lexicale de la chaine de caracteres a partir de la grammaire : */
/*	Chaine  : Somme                    	*/
/*	Somme   : Produit + Somme | Produit     */
/*	Produit : Signal * Produit | EPS        */
/*	Signal  : Variable | /Variable          */

int signal(list_var)
    varia * list_var;
{
    char lex;

    lex = lire_c();

    if (lex == '/')
	chaine ++;

    if (list_var == NULL)
	return lire_identifiant_c();
    else
	return lire_identifiant_chaine(list_var);
}


int produit(list_var)
    varia * list_var;
{
    char lex;
    int temp;

    temp = 0;

    if (signal(list_var))
	temp = 1;

    lex = lire_c();

    if ((lex == '*') && (temp))
    {
	chaine++;
	if (produit(list_var))
	    return 1;
	else
	    return 0;
    }
    else
	return temp;
}


int somme(list_var)
    varia * list_var;
{
    int temp;
    char lex;

    temp = 0;

    if (produit(list_var))
	temp = 1;

    lex = lire_c();
    if ((lex == '+') && (temp))
    {
	chaine ++;
	if (somme(list_var))
	    return 1;
	else
	    return 0;
    }

    if ((lex == '\0') && (temp))
	return 1;
    else
	return 0;
}


/* Retourne le poids de la variable lue */

int poids_c()
{
    while (*chaine == ' ')
	chaine ++;

    return (TAILLE-(*chaine)+97);
}


/* Idem pour les variables de l'utilisateur */

int poids_chaine(list_var)
    varia * list_var;
{
    int k;
    char c;
    char * copi, * renvoi, * prov;

    renvoi = (char *) malloc(50);

    k = 0;
    prov = chaine;

    while (*prov == ' ')
	prov ++;
    copi = prov;

    while (isalnum(*prov))
    {
	prov++;
	k++;
    }
    c = *prov;
    *prov = '\0';
    strncpy(renvoi,copi,k+1);
    *prov = c;
    chaine = prov;
    k = 0;

    while (list_var != NULL)
    {
	if (!strcmp(renvoi,list_var->var))
	{
	    free(renvoi);
	    return (TAILLE - k);
	}
	k ++;
	list_var = list_var->suiv;
    }
    free(renvoi);

    return 0;
}


/* Les trois fonctions suivantes analysent la chaine et */
/* renvoient les valeurs binaires des differents termes */

poids_var * converse_signal(list_var)
    varia * list_var;
{
    poids_var * poids = (poids_var *)malloc(sizeof(poids_var));
    char c;

    c = lire_c();
    if (c == '/')
    {
	poids->valeur=0;
	chaine ++;
    }
    else
	poids->valeur = 1;
    if (list_var == NULL)
    {
	poids->poids = poids_c();
	chaine ++;
    }
    else
	poids->poids = poids_chaine(list_var);

    poids->suiv = NULL;

    return poids;
}


tab_var * converse_produit(list_var)
    varia * list_var;
{
    tab_var * tab_renvoi = (tab_var*) malloc(sizeof(tab_var));
    poids_var * provisoire;
    int fin = 0;

    tab_renvoi->terme = converse_signal(list_var);
    provisoire = tab_renvoi->terme;

    while (!fin)
    {
	if (lire_c() == '*')
	{
	    chaine ++;
	    provisoire->suiv = converse_signal(list_var);
	    provisoire = provisoire->suiv;
	}
	else
	    fin = 1;
    }
    tab_renvoi->suiv = NULL;

    return tab_renvoi;
}


tab_var * converse_somme(list_var)
    varia * list_var;
{
    tab_var * TAB, * tab_prov;
    int fin = 0;

    TAB = converse_produit(list_var);
    tab_prov = TAB;

    while(!fin)
    {
	if (lire_c() == '+')
	{
	    chaine ++;
	    tab_prov->suiv = converse_produit(list_var);
	    tab_prov = tab_prov->suiv;
	}
	else
	    fin = 1;
    }
    return TAB;
}


int mise_a_jour(bin_v)
    bin ** bin_v;
{
    int k, vrai, c;
    bin * copi;

    copi = *bin_v;
    vrai = 1;
    k = 1;
    c = 1;

    while((copi != NULL) && (vrai))
    {
	if (copi->bin == 0)
	{
	    copi->bin = 1;
	    vrai = 0;
	}
	else
	{
	    k++;
	    copi = copi->suiv;
	}
    }
    if (vrai)
	return 0;
    else
    {
	copi = *bin_v;
	while (c < k)
	{
	    copi->bin = 0;
	    copi = copi->suiv;
	    c ++;
	}
	return 1;
    }
}


/* Calcule la puissance (n-1)eme de 2 */

int puissance_2(n)
    int n;
{
    int p, s;

    p = 1;
    s = 1;

    while (p < n)
    {
	s = s * 2;
	p ++;
    }
    return s;
}


int interpretation(liste)
    bin * liste;
{
    int somme;

    somme = 0;
    while (liste != NULL)
    {
	somme = somme + puissance_2(liste->poids) * liste->bin;
	liste = liste->suiv;
    }
    return somme;
}


int cal(p)
    poids_var * p;
{
    int val;

    val = 0;

    while (p != NULL)
    {
	val = val + p->valeur * puissance_2(p->poids);
	p = p->suiv;
    }
    return val;
}


list_bin * cons_bin(tab)
    tab_var * tab;
{
    list_bin * bin_envoi,* liste_bin;
    int debut, debut_bin, present, i;
    bin * bin_var;
    poids_var * parcours;

    debut_bin = 1;

    while(tab != NULL)
    {
	debut = 1;
	for(i=1;i<=TAILLE;i++)
	{
	    present = 1;
	    parcours = tab->terme;
	    while ((parcours != NULL) && (present))
	    {
		if (parcours->poids == i)
		    present = 0;
		parcours = parcours->suiv;
	    }
	    if (present == 1)
	    {
		if (debut)
		{
		    if (debut_bin)
		    {
			liste_bin = new_list_bin(cal(tab->terme));
			bin_envoi = liste_bin;
			debut_bin  = 0;
		    }
		    else
		    {
			liste_bin->suiv = new_list_bin(cal(tab->terme));
			liste_bin = liste_bin->suiv;
		    }
		    bin_var = new_bin(i,0);
		    liste_bin->terme = bin_var;
		    debut = 0;
		}
		else
		{
		    bin_var->suiv = new_bin(i,0);
		    bin_var = bin_var->suiv;
		}
	    }
	}
	if (debut)
	{
	    if (debut_bin)
	    {
		liste_bin = new_list_bin(cal(tab->terme));
		bin_envoi = liste_bin;
		debut_bin  = 0;
	    }
	    else
	    {
		liste_bin->suiv = new_list_bin(cal(tab->terme));
		liste_bin = liste_bin->suiv;
	    }
	}
	tab = tab->suiv;
    }

    return bin_envoi;
}


void entry(comp,list_binaire)
    mint ** comp;
    list_bin * list_binaire;
{
    int i, debut, valeur;
    mint * ent;
    bin * binaire;

    debut = 1;
    *comp = new_mint(list_binaire->valeur);
    ent = *comp;

    while (list_binaire != NULL)
    {
	valeur = list_binaire->valeur;
	if ( !debut)
	{
	    ent->next = new_mint(valeur);
	    ent = ent->next;
	}

	binaire = list_binaire->terme;
	while(mise_a_jour(&binaire))
	{
	    i = interpretation(binaire);
	    ent->next = new_mint(i + valeur);
	    ent = ent->next;
	}
	list_binaire = list_binaire->suiv;
	debut = 0;
    }
}


/* Fonction principale d'analyse de la chaine : retourne */
/* la liste des minterms qu'elle represente */

mint * entree_chaine(list_var,taille)
    varia * list_var;
    int taille;
{
    mint * comp, * temp;
    char * copi;
    tab_var * TAB;
    list_bin * liste_bin;
    int i;

    chaine = (char*)malloc(100);

    liste_bin = NULL;
    TAB = NULL;
    copi = chaine;

    printf("\tExpression logique : ");
    fflush(stdin);
    scanf("%s",chaine);
    TAILLE = taille;

    if (!strcmp(chaine,"1"))
    {
	comp = new_mint(0);
	temp = comp;
	taille = 1 << taille;
	for (i = 1; i < taille; i++)
	{
	    temp->next = new_mint(i);
	    temp = temp->next;
	}
    }
    else
    {
	if (somme(list_var))
	{
	    chaine = copi;
	    TAB = converse_somme(list_var);
	    liste_bin = cons_bin(TAB);
	    entry(&comp,liste_bin);
	}
	else
	    comp = NULL;
    }

    free(copi);
    del_list_bin(liste_bin);
    del_tab_var(TAB);

    return comp;
}
