/**************************************************/
/* Fichier contenant les fonctions d'entree et de */
/*    traitement pour les circuits sequentiels    */
/**************************************************/



#include <stdio.h>
#include "struct.h"
#include "pointeur.h"
#include "lex.h"
#include "scrut.h"


/* Retourne 1 si i n'appartient pas au bin * b */

int not_in(b,i)
    bin * b;
    int i;
{
    int ret = 1;

    while ((b != NULL) && (ret))
    {
	if (b->poids == i)
	    ret = 0;
	else
	    b = b->suiv;
    }
    return ret;
}


/* Calcule la valeur de 2^i */

int puis(i)
    int i;
{
    int j;
    int s = 1;

    for (j = 1; j <= i; j++)
	s = s*2;

    return s;
}


/* Retourne 1 si i n'appartient pas a la list_bin * l */

int not_app(l,i)
    list_bin * l;
    int i;
{
    int ret = 1;

    while ((l != NULL) && (ret))
    {
	if (l->valeur == i)
	    ret = 0;
	else
	    l = l->suiv;
    }
    return ret;
}

void affiche_etat(liste_etat)
    mint * liste_etat;
{
    printf("\nEtat(s) deja defini(s) :\n");
    while(liste_etat != NULL)
    {
	printf("            etat %d\n",liste_etat->numero);
	liste_etat = liste_etat->next;
    }
}


mint * concat_etat(liste_etat,numero)
    int numero;
    mint * liste_etat;
{
    mint * temp;

    temp = liste_etat;

    if (temp == NULL)
	return new_mint(numero);
    else
    {
	while ((temp->next) != NULL)
	    temp = temp->next;
	temp->next = new_mint(numero);
	return liste_etat;
    }
}


/* Fonction traitant l'entree des etats et des */
/* differentes transitions */

list_bin * sequent(in,ex,list_var)
    int in, ex;
    varia * list_var;
{
    list_bin * l, * li;
    int i, j, k, compt, cpex;
    bin * b;
    mint * comp, * c, * liste_etat;

    liste_etat = NULL;
    in = puis(in);
    cpex = ex;
    ex = puis(ex);

    l = NULL;
    i = 0;
    comp = NULL;

    printf("\n");
    while (i != 100)
    {
	i = in;
	while ((i < 0) || ((i != 100) && (i >= in)))
	{
	    if (liste_etat != NULL)
		affiche_etat(liste_etat);
	    printf("Etat ? ");
	    i=scrut();
	}

	if (i != 100)
	{
	    liste_etat = concat_etat(liste_etat,i);
	    if (l == NULL)
	    {
		l = new_list_bin(i);
		li = l;
	    }
	    else
	    {
		li->suiv = new_list_bin(i);
		li = li->suiv;
	    }
	    j = 0;
	    while ((j != 100) && (j != ex))
	    {
		if (ex == 1)
		    j = ex;   /* il n'y a pas d'entree */
		else
		{
		    comp = entree_chaine(list_var,cpex);

		    if (comp == NULL)
			j = 100;
		    else
			j = 0;
		}
		if (j != 100)
		{
		    k = in;
		    while ((k < 0) || (k >= in))
		    {
			printf("\tNouvel etat ? ");
			k=scrut();
		    }
		    printf("\n");

		    if (j == ex)
		    {
			/* quelle que soit l'entree, on ira
			   dans l'etat k */

			li->terme = new_bin(0,k);
			b = li->terme;
			for (compt = 1; compt < ex; compt++)
			{
			    b->suiv = new_bin(compt,k);
			    b = b->suiv;
			}
		    }
		    else
		    {
			c = comp;
			j = 0;
			while (c != NULL)
			{
			    if (li->terme == NULL)
			    {
				li->terme = new_bin(c->numero,k);
				b = li->terme;
				j++;
			    }
			    else
			    {
				b->suiv = new_bin(c->numero,k);
				b = b->suiv;
				j++;
			    }
			    c = c->next;
			}
			del_mint(comp);
		    }
		}
		else
		{
		    /* lorsqu'une entree n'est pas precisee, on
		       reste au meme etat */

		    for (compt = 0; compt < ex; compt++)
		    {
			if (not_in(li->terme,compt))
			{
			    if (li->terme == NULL)
			    {
				li->terme = new_bin(compt,i);
				b = li->terme;
			    }
			    else
			    {
				b->suiv = new_bin(compt,i);
				b = b->suiv;
			    }
			}
		    }
		}
	    }
	    printf("\n");
	}
    }

    del_mint(liste_etat);

    for (i = 0; i < in; i++)
    {
	/* si l'etat i n'a pas ete defini, on considere
	   que cet etat donnera lieu a des transitions
	   quelconques --> fonctions incompletes */

	if (not_app(l,i))
	{
	    if (l == NULL)
	    {
		l = new_list_bin(i);
		li = l;
	    }
	    else
	    {
		li->suiv = new_list_bin(i);
		li = li->suiv;
	    }
	}
    }

    return l;
}


/* Transforme les donnees obtenues par la fonction */
/* precedente en une structure mieux exploitable */

trans * expres(l,in,ex)
    list_bin * l;
    int in, ex;
{
    trans * t, * tr;
    int i, compt;
    list_bin * li;
    bin * b;
    mint * m, * mi;

    t = NULL;
    for (compt = 0; compt < in; compt++)
    {
	/* pour chaque variable interne (etat) */

	if (t == NULL)
	{
	    t = new_trans(compt);
	    tr = t;
	}
	else
	{
	    tr->suiv = new_trans(compt);
	    tr = tr->suiv;
	}
	li = l;
	while (li != NULL)
	{
	    if (li->terme == NULL)
	    {
		/* les transitions pour cet etat (li->valeur)
		   n'ont pas ete precisees --> fonction incomplete */

		for (i = 0; i < puis(ex); i++)
		{
		    if (tr->incomp == NULL)
		    {
			tr->incomp = new_mint(i*puis(in) + li->valeur);
			mi = tr->incomp;
		    }
		    else
		    {
			mi->next = new_mint(i*puis(in) + li->valeur);
			mi = mi->next;
		    }
		}
	    }

	    b = li->terme;
	    while (b != NULL)
	    {
		/* si le nouvel etat place cette variable interne a 1 */
		if (b->bin & puis(compt))
		{
		    if (tr->comp == NULL)
		    {
			tr->comp = new_mint(b->poids*puis(in) + li->valeur);
			m = tr->comp;
		    }
		    else
		    {
			m->next = new_mint(b->poids*puis(in) + li->valeur);
			m = m->next;
		    }
		}
		b = b->suiv;
	    }
	    li = li->suiv;
	}
    }

    return t;
}


/* Fonction de decomposition des fonctions initiales */

trans * decomp(t)
    trans * t;
{
    trans * tr, * tra, * temp;
    int i;
    mint * m1, * m2, * mi;

    tr = NULL;
    temp = t;
    while (temp != NULL)
    {
	/* pour chaque variable interne Q (etat) */

	if (tr == NULL)
	{
	    tr = new_trans(temp->var);
	    tra = tr;
	}
	else
	{
	    tra->suiv = new_trans(temp->var);
	    tra = tra->suiv;
	}

	/* traitement des fonctions completes */
	mi = temp->comp;
	while (mi != NULL)
	{
	    if (mi->numero & puis(temp->var))
	    {
		/* termes contenant Q sous la forme Q */

		if (tra->comp == NULL)
		{
		    tra->comp = new_mint(mi->numero);
		    m1 = tra->comp;
		}
		else
		{
		    m1->next = new_mint(mi->numero);
		    m1 = m1->next;
		}
		m1->next = new_mint(mi->numero - puis(temp->var));
		m1 = m1->next;
	    }
	    else
	    {
		/* termes contenant Q sous la forme /Q */

		if (tra->comp1 == NULL)
		{
		    tra->comp1 = new_mint(mi->numero);
		    m2 = tra->comp1;
		}
		else
		{
		    m2->next = new_mint(mi->numero);
		    m2 = m2->next;
		}
		m2->next = new_mint(mi->numero + puis(temp->var));
		m2 = m2->next;
	    }
	    mi = mi->next;
	}

	/* traitement des fonctions incompletes */
	mi = temp->incomp;
	while (mi != NULL)
	{
	    if (mi->numero & puis(temp->var))
	    {
		if (tra->incomp == NULL)
		{
		    tra->incomp = new_mint(mi->numero);
		    m1 = tra->incomp;
		}
		else
		{
		    m1->next = new_mint(mi->numero);
		    m1 = m1->next;
		}
		m1->next = new_mint(mi->numero - puis(temp->var));
		m1 = m1->next;
	    }
	    else
	    {
		if (tra->incomp1 == NULL)
		{
		    tra->incomp1 = new_mint(mi->numero);
		    m2 = tra->incomp1;
		}
		else
		{
		    m2->next = new_mint(mi->numero);
		    m2 = m2->next;
		}
		m2->next = new_mint(mi->numero + puis(temp->var));
		m2 = m2->next;
	    }
	    mi = mi->next;
	}

	temp = temp->suiv;
    }

    del_trans(t);

    return tr;
}
